/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.batch.planner.model.impl;

import com.liferay.batch.planner.model.BatchPlannerLog;
import com.liferay.batch.planner.service.BatchPlannerLogLocalServiceUtil;

/**
 * The extended model base implementation for the BatchPlannerLog service. Represents a row in the &quot;BatchPlannerLog&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This class exists only as a container for the default extended model level methods generated by ServiceBuilder. Helper methods and all application logic should be put in {@link BatchPlannerLogImpl}.
 * </p>
 *
 * @author Igor Beslic
 * @see BatchPlannerLogImpl
 * @see BatchPlannerLog
 * @generated
 */
public abstract class BatchPlannerLogBaseImpl
	extends BatchPlannerLogModelImpl implements BatchPlannerLog {

	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this class directly. All methods that expect a batch planner log model instance should use the <code>BatchPlannerLog</code> interface instead.
	 */
	@Override
	public void persist() {
		if (this.isNew()) {
			BatchPlannerLogLocalServiceUtil.addBatchPlannerLog(this);
		}
		else {
			BatchPlannerLogLocalServiceUtil.updateBatchPlannerLog(this);
		}
	}

}